Below is a summary of the contents of each file in the "trained" and "crafted" directories. The synthetic data used for these experiments is in "synthetic_data.csv". The crafted experiment contains no error files, since all errors are 0 by design. 

sum_synthetic.csv
---------------
The dataset used in the synthetic experiment.

shap_values.csv
---------------
Contains the shap value for each feature, for each instance in the dataset.

feature_influence_scores.png
---------------
A plot of the mean absolute SHAP value for each feature. 

reconstruction_error_<variable_name>.csv
---------------
For each feature, the recunstriction error between x and x_hat when that feature was the protected feature. In other words, the error between the reconstructed feature matrix and the original feature matrix, for the given protected feature. 

prediction_error.csv
---------------
For each feature, the mean squared error between g(x) and g(x_hat) when that feature was the protected feature. In other words, the mean squared error between the prediction on the original vs reconstructed data, for each protected feature. 

discriminator_error.csv
---------------
For each feature, the error between p and p_hat when that feature was the protected feature. In other words, the error between the protected feature and the discriminator's prediction, for each protected feature. 
Important note of interpretation for these values. This should be considered in relation to the variance of the feature. If the discriminator predicts the expected value of the protected feature every time (i.e. can't reveal any protected information), its MSE would be equal to the variance of the feature (correct me if I am wrong). x, y and z are distributed Unif(0,1) so this means a "good" disentanglement result would be 1/12=0.0833 for the discriminator MSE value for these features. If I am correct in this interpretation, we may want to report these values standardized by feature variance, so that a score of 1 is best, and below 1 indicates revealed protected information. 

